struct A { };
struct B { };
struct A_D : public A { };

struct A_applicator {
	virtual void apply( A ) { }
};
struct B_applicator {
	virtual void apply( B ) { }
};
struct dual_applicator : public B_applicator, public A_applicator {
	using B_applicator::apply;
	using A_applicator::apply;
};

int main() {
	dual_applicator app;
	A_D d;
	app.apply(d);
}
