#include <iostream>

template<typename T>
void apply(T const & value ) {
	std::cout << "apply" << std::endl;
}

struct my_type { };
void apply(my_type const & value ) {
	std::cout << "my_type" << std::endl;
}

int main() {
	apply( my_type() );
	my_type a;
	apply( a );
	apply( static_cast<my_type const>(a) );
	apply( static_cast<my_type const &>(a) );
}
